module ComposedCriteria where

import CeTA
import SN
import PRLCert
import PCPSCert
import ReductionMethod

prlAndPcps :: String -> Tool -> Int -> CriterionCert
prlAndPcps smt tt k trsR =
  PRLCert.compositionalPRL smt ks cr trsR
  where 
    ks = if k <= 2 then [k] else [2,k]
    cr trsC = PCPSCert.hm11 (SN.snCert tt) k trsC 

pcpsAndPrl :: String -> Tool -> Int -> CriterionCert
pcpsAndPrl smt tt k trsR =
  PCPSCert.pcpsCriterion (SN.snCert tt) k True cr trsR
  where 
    ks = if k <= 2 then [k] else [2,k]
    cr trsC = PRLCert.prl smt ks trsC

prlAndPcps_or_pcpsAndPrl :: String -> Tool -> Int -> CriterionCert
prlAndPcps_or_pcpsAndPrl smt tt k trsR = do
  m <- prlAndPcps smt tt k trsR
  case m of
    Nothing -> pcpsAndPrl smt tt k trsR
    _       -> return m

full :: String -> Tool -> Int -> CriterionCert
full smt tt k trsR = 
  reduce smt ks (prlAndPcps_or_pcpsAndPrl smt tt k) trsR
  where
    ks = if k <= 2 then [k] else [2,k]

